// Author: A.Voss@FH-Aachen.de
//
// program shows how to start a simple thread, note -pthread in make
// tags: thread

#include <iostream>
#include <thread>
#include <condition_variable>
#include <chrono>
#include <string>
using namespace std;

#include "../../include/tools.h"

// thread-function with one int-param
void Work(int secs) 
{
    tools_log(); cout << "thread started, sleep for " << secs << " sec" << endl;

    // sleep for some secs
    this_thread::sleep_for(chrono::seconds(secs));
   
    tools_log(); cout << "thread done" << endl;     
}

int main()
{
    tools_log(); cout << "start threads t1 and t2" << endl;

    // start a new thread and execute function Work
    thread t1(Work,5);      tools_registerthreadname(t1); // identify threads with names
    thread t2(Work,2);      tools_registerthreadname(t2);

    tools_log(); cout << "and wait for join" << endl;

    // wait for threads
    t1.join();
    tools_log(); cout << "t1 joined, done" << endl;
    
    t2.join();
    tools_log(); cout << "t2 joined, done" << endl;
         
    return EXIT_SUCCESS;
}
