// Author: A.Voss@FH-Aachen.de
//
// use references as parameters in working function
// tags: thread, ref

#include <iostream>
#include <thread>
#include <condition_variable>
#include <chrono>
#include <string>
using namespace std;

#include "../../include/tools.h"

// thread-function with one int-reference
void Work(int & secs) 
{
    tools_log(); cout << "thread started, sleep for " << secs << " sec" << endl;

    // sleep for some secs
    this_thread::sleep_for(chrono::seconds(secs));
    
    // set value!
    secs = -42;
   
    tools_log(); cout << "thread done" << endl;     
}

int main()
{
    tools_log(); cout << "start thread" << endl;

    // start a new thread with reference param
    int secs = 1;
    thread t(Work,ref(secs));   // note: ref() makes a ref

    tools_log(); cout << "and wait for join" << endl;

    // wait for thread
    t.join();
    tools_log(); cout << "t joined, secs=" << secs << ", done" << endl;
         
    return EXIT_SUCCESS;
}
